#ifndef __SKY_200_H_
#define __SKY_200_H_
#include <linux/ioctl.h>

// major number
#define SM200_MAJOR		0

// Use 's' as magic number of ioctl
#define SM200_IOC_MAGIC	's'

#define SM200_IOCRESET	_IO(SM200_IOC_MAGIC, 0)
/*
 * S means 'Set' through a ptr
 * T means 'Tell' directly with the argument value
 * G means 'Get' : reply by setting through a pointer
 * Q means 'Query' : reponse is on the return value
 * X means 'eXchange' : G and S atomically
 * H means 'sHift' : T and Q atomically
 */
#define SM200_IOCSCODE_HEADER		_IO(SM200_IOC_MAGIC, 1)
#define SM200_IOCSCODE_LENGTH		_IO(SM200_IOC_MAGIC, 2)
#define SM200_IOCSCODE_STACKSIZE	_IO(SM200_IOC_MAGIC, 3)
#define SM200_IOCSCODE_HEAPSIZE		_IO(SM200_IOC_MAGIC, 4)
#define SM200_IOCSCODE_DATA	    	_IO(SM200_IOC_MAGIC, 5)
#define SM200_IOCSCODE_END		    _IO(SM200_IOC_MAGIC, 6)

#define SM200_IOCSTUNERSET		    _IO(SM200_IOC_MAGIC, 7)
#define SM200_IOCGTUNERRESULT		_IO(SM200_IOC_MAGIC, 8)
#define SM200_IOCSPROGRAMPIDSET		_IO(SM200_IOC_MAGIC, 9)
#define SM200_IOCSPROGRAMPIDRELEASE	_IO(SM200_IOC_MAGIC, 10)
#define SM200_IOCSAUDIOPIDSET       _IO(SM200_IOC_MAGIC, 11)
#define SM200_IOCSNETWORKPIDSET		_IO(SM200_IOC_MAGIC, 12)
#define SM200_IOCSNETWORKPIDRELEASE	_IO(SM200_IOC_MAGIC, 13)
#define SM200_IOCSALLNETWORKPIDRELEASE  _IO(SM200_IOC_MAGIC, 14)
#define SM200_IOCSSENDIPADDRESS		_IO(SM200_IOC_MAGIC, 15)
#define SM200_IOCGGETMACADDRESS		_IO(SM200_IOC_MAGIC, 16)
#define SM200_IOCGGETVIDEOMODE		_IO(SM200_IOC_MAGIC, 17)
#define SM200_IOCGGETAUDIOSAMPLRATE	_IO(SM200_IOC_MAGIC, 18)
#define SM200_IOCSCANCELSCANPROGRAM	_IO(SM200_IOC_MAGIC, 19)
#define SM200_IOCSSETAUDIOCONTROL	_IO(SM200_IOC_MAGIC, 20)
#define SM200_IOCGGETAUDIOCONTROL	_IO(SM200_IOC_MAGIC, 21)
#define SM200_IOCGGETMODIFIEDTUNER	_IO(SM200_IOC_MAGIC, 22)
#define SM200_IOCSSETIPORMACFILTERING	_IO(SM200_IOC_MAGIC, 23)
#define SM200_IOCGGETFIRMWAREVERSION	_IO(SM200_IOC_MAGIC, 24)
#define SM200_IOCGGETDRIVERVERSION	_IO(SM200_IOC_MAGIC, 25)
#define SM200_IOCSREGISTERAPP       	_IO(SM200_IOC_MAGIC, 26)
#define SM200_IOCSUNREGISTERAPP     	_IO(SM200_IOC_MAGIC, 27)
#define SM200_IOCGGETPROGRAMINFO	_IO(SM200_IOC_MAGIC, 28)
#define SM200_IOCGSCANPROGRAM		_IO(SM200_IOC_MAGIC, 29)
#define SM200_IOCGGETSCANSTATUS		_IO(SM200_IOC_MAGIC, 30)
#define SM200_IOCSRESETBOARD        	_IO(SM200_IOC_MAGIC, 31)
#define SM200_IOCSNETWORKINTERFACE	_IO(SM200_IOC_MAGIC, 32)
#define SM200_IOCSREGISTERMAC		_IO(SM200_IOC_MAGIC, 33)

#define SM200_IOCSSTARGUPGRADE		_IO(SM200_IOC_MAGIC, 34)
#define SM200_IOCGGETBANK		_IO(SM200_IOC_MAGIC, 35)
#define SM200_IOCSWRITEFIRMWARE		_IO(SM200_IOC_MAGIC, 36)
#define SM200_IOCGGETWRITESTATUS		_IO(SM200_IOC_MAGIC, 37)
#define SM200_IOCSWRITEFIRMDATA		_IO(SM200_IOC_MAGIC, 38)
#define SM200_IOCSWRITEFIRMEND		_IO(SM200_IOC_MAGIC, 39)



#define SM200IOCTL	SIOCDEVPRIVATE

typedef struct sm200_ioctl_s {
	unsigned short 	cmd;
	unsigned int	len;
	union {
		unsigned char	*datap;
		unsigned int	data;
	} dt;
} sm200_ioctl_t;

#endif
